
clear all
close all
global uss xss a b c d ud
global red_n n tp pt  

a = [-2 0 0 ;1 -1.1 0; 0 0.1 -1];
b = [2; 0;0 ];
c = [0 0 1];
d = [0];

uss = 2;
xss = -1*inv(a)*b*uss;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% test the unscaled system 
sys = ss(a,b,c,d);

%%%%%%% a: by the MATLAB command
Wc = gram(sys,'c');
Wo = gram(sys,'o');
[sysb,G,T] = balreal(sys);
Wcb = gram(sysb,'c');
Wob = gram(sysb,'o');

%%%%%%% b: by our own matlab routines
Wc_1 = ctrl_gram_cov_unscaled('lin_example',[0 6 .1],[1 3 1 2 1000],[.1],uss,xss,0);
Wo_1 = obsv_gram_cov_unscaled('lin_example',[0 6 .1],[1 3 1 2 1000],[.1],[3],uss,xss,0);
[Trans_un, invTrans_un, Wcb_1, Wob_1, svd_Wcb_1, svd_Wob_1] = bal_realization(Wc_1,Wo_1,3);

% comments: Wc should be almost equal to Wc_1 and Wo should be almost equal to Wo_1.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% test the scaled system
tx = diag(xss);
tu = diag(uss);
abar = inv(tx)*a*tx;
bbar = inv(tx)*b*tu;
cbar = c*tx;
dbar = [0];
sysbar = ss(abar,bbar,cbar,dbar);

%%%%%%% a: by the MATLAB command
Wcbar = gram(sysbar,'c');
Wobar = gram(sysbar,'o');

%%%%%%% b: by our own matlab routines
Wcbar_1 = ctrl_gram_cov('lin_example_scaled',[0 6 .1],[1 3 1 2 1000], 0.1,0);
Wobar_1 = obsv_gram_cov('lin_example_scaled',[0 6 .1],[1 3 1 2 1000], 0.1,[3],xss,0);
[Trans, invTrans, Wcbbar_1, Wobbar_1, svd_Wcbbar_1, svd_Wobbar_1] = bal_realization(Wcbar_1,Wobar_1,3);
save lin_example_matrix Trans invTrans Wcbbar_1 Wobbar_1 svd_Wcbbar_1 svd_Wobbar_1

% comments: Wcbar should be almost equal to Wcbar_1 and Wobar should be almost equal to Wobar_1.

