
clear all
close all
global uss xss a b c d ud
global red_n n Trans invTrans  

a = [-2 0 0 ;1 -1.1 0; 0 0.1 -1];
b = [2; 0;0 ];
c = [0 0 1];
d = [0];

uss = 2;
xss = -1*inv(a)*b*uss;

load lin_example_matrix
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% test the reduced order systems by comparing step response with the original system
% Set the input
cm = 0.1;

ud=1-cm; 
n = 3;
% initial states
initvalue = ones(n,1);      

% integrate the original system
[t, y] = ode15s('lin_example_scaled',[0 10], initvalue);
% Copy data for real system
y0(:,1) = xss(3)*y(:,3);
t0 = t;

% retaining 2 states
red_n = 2;
% initial states
initvalue = Trans*ones(n,1);
    
% integrate the reduced system
[t, y] = ode15s('lin_example_scaled_red',[0 10], initvalue);
y = (invTrans*y')';

% Copy data for reduced system 
y2(:,1) = xss(3)*y(:,3);
t2 = t;

figure(1);
plot(t0,y0(:,1),'k-',t2,y2(:,1),'k--');
xlabel('Time ');
ylabel('Third state ');
title('Comparison');
full = strcat('full-order: 3 states');
red_2 = strcat('reduced-order: 2 states');

legend(full,red_2,0);
top = max([y0(:,1);y2(:,1)]);
bot = min([y0(:,1);y2(:,1)]);
dif = (top-bot)*0.25;
axis([0 10 (bot-dif) (top+dif)]);


